/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"encoding/json"
)

// checks if the GetOrgQuotaResponse type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GetOrgQuotaResponse{}

// GetOrgQuotaResponse struct for GetOrgQuotaResponse
type GetOrgQuotaResponse struct {
	// The number of CVE IDs the organization is allowed to have in the RESERVED state at one time.
	IdQuota *int32 `json:"id_quota,omitempty"`
	// The total number of CVE IDs across all years that the organization has in the RESERVED state.
	TotalReserved *int32 `json:"total_reserved,omitempty"`
	// The number of CVE IDs that can be reserved by the organization. (e.g., id_quota - total_reserved)
	Available *int32 `json:"available,omitempty"`
}

// NewGetOrgQuotaResponse instantiates a new GetOrgQuotaResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGetOrgQuotaResponse() *GetOrgQuotaResponse {
	this := GetOrgQuotaResponse{}
	return &this
}

// NewGetOrgQuotaResponseWithDefaults instantiates a new GetOrgQuotaResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGetOrgQuotaResponseWithDefaults() *GetOrgQuotaResponse {
	this := GetOrgQuotaResponse{}
	return &this
}

// GetIdQuota returns the IdQuota field value if set, zero value otherwise.
func (o *GetOrgQuotaResponse) GetIdQuota() int32 {
	if o == nil || IsNil(o.IdQuota) {
		var ret int32
		return ret
	}
	return *o.IdQuota
}

// GetIdQuotaOk returns a tuple with the IdQuota field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetOrgQuotaResponse) GetIdQuotaOk() (*int32, bool) {
	if o == nil || IsNil(o.IdQuota) {
		return nil, false
	}
	return o.IdQuota, true
}

// HasIdQuota returns a boolean if a field has been set.
func (o *GetOrgQuotaResponse) HasIdQuota() bool {
	if o != nil && !IsNil(o.IdQuota) {
		return true
	}

	return false
}

// SetIdQuota gets a reference to the given int32 and assigns it to the IdQuota field.
func (o *GetOrgQuotaResponse) SetIdQuota(v int32) {
	o.IdQuota = &v
}

// GetTotalReserved returns the TotalReserved field value if set, zero value otherwise.
func (o *GetOrgQuotaResponse) GetTotalReserved() int32 {
	if o == nil || IsNil(o.TotalReserved) {
		var ret int32
		return ret
	}
	return *o.TotalReserved
}

// GetTotalReservedOk returns a tuple with the TotalReserved field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetOrgQuotaResponse) GetTotalReservedOk() (*int32, bool) {
	if o == nil || IsNil(o.TotalReserved) {
		return nil, false
	}
	return o.TotalReserved, true
}

// HasTotalReserved returns a boolean if a field has been set.
func (o *GetOrgQuotaResponse) HasTotalReserved() bool {
	if o != nil && !IsNil(o.TotalReserved) {
		return true
	}

	return false
}

// SetTotalReserved gets a reference to the given int32 and assigns it to the TotalReserved field.
func (o *GetOrgQuotaResponse) SetTotalReserved(v int32) {
	o.TotalReserved = &v
}

// GetAvailable returns the Available field value if set, zero value otherwise.
func (o *GetOrgQuotaResponse) GetAvailable() int32 {
	if o == nil || IsNil(o.Available) {
		var ret int32
		return ret
	}
	return *o.Available
}

// GetAvailableOk returns a tuple with the Available field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetOrgQuotaResponse) GetAvailableOk() (*int32, bool) {
	if o == nil || IsNil(o.Available) {
		return nil, false
	}
	return o.Available, true
}

// HasAvailable returns a boolean if a field has been set.
func (o *GetOrgQuotaResponse) HasAvailable() bool {
	if o != nil && !IsNil(o.Available) {
		return true
	}

	return false
}

// SetAvailable gets a reference to the given int32 and assigns it to the Available field.
func (o *GetOrgQuotaResponse) SetAvailable(v int32) {
	o.Available = &v
}

func (o GetOrgQuotaResponse) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GetOrgQuotaResponse) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.IdQuota) {
		toSerialize["id_quota"] = o.IdQuota
	}
	if !IsNil(o.TotalReserved) {
		toSerialize["total_reserved"] = o.TotalReserved
	}
	if !IsNil(o.Available) {
		toSerialize["available"] = o.Available
	}
	return toSerialize, nil
}

type NullableGetOrgQuotaResponse struct {
	value *GetOrgQuotaResponse
	isSet bool
}

func (v NullableGetOrgQuotaResponse) Get() *GetOrgQuotaResponse {
	return v.value
}

func (v *NullableGetOrgQuotaResponse) Set(val *GetOrgQuotaResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableGetOrgQuotaResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableGetOrgQuotaResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGetOrgQuotaResponse(val *GetOrgQuotaResponse) *NullableGetOrgQuotaResponse {
	return &NullableGetOrgQuotaResponse{value: val, isSet: true}
}

func (v NullableGetOrgQuotaResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGetOrgQuotaResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


